; Booster Grip Adapter Test Program
; Charles Wieland, 7/2/1998
; junkosoft.org

	processor 6502
	include vcs.h

	ORG $F000

TEMP = $80

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00
	
clrstk  STA $00,X
	DEX
	BNE clrstk
	LDA #$0F
	STA COLUPF
	LDA #$01
	STA CTRLPF

vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC

doscrn  LDA INTIM
	BNE doscrn

	; Reset Booster and Trigger Buttons on Booster Grip
	LDA #$80
	STA VBLANK

chk1    LDA INPT4
	AND #$80
	BNE chk2

set1    LDA TEMP
	ADC #$20
	STA TEMP

chk2    LDA INPT0
	AND #$80
	BEQ chk3

set2    LDA TEMP
	ADC #$08
	STA TEMP

chk3    LDA INPT1
	AND #$80
	BEQ dodraw

set3    LDA TEMP
	ADC #$02
	STA TEMP

dodraw  LDA #$00
	STA WSYNC
	STA VBLANK
	LDA TEMP
	STA PF2
	LDX #$C0
drawscr STA WSYNC
	DEX
	BNE drawscr
	STA WSYNC
	STA VBLANK
	STX PF0
	STX PF1
	STX PF2
	STX TEMP
	
oscan   LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
	.word Start
