; Multi colored sprite demo
; Charles Wieland, 8/13/1998
; junkosoft.org

	processor 6502
	include vcs.h

	ORG $F000

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00
	
clrstk  STA $00,X
	DEX
	BNE clrstk
	LDA #$07
	STA NUSIZ0
	LDA #$01
	STA CTRLPF
	LDA #$FF
	STA SWACNT

	LDX #$5C
topfrm  STA WSYNC
	DEX
	BNE topfrm
	STA RESP0
	LDX #$02
	STA WSYNC
	LDX #$63
btmfrm  STA WSYNC
	DEX
	BNE btmfrm

vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC

doscrn  LDA INTIM
	BNE doscrn

dodraw  LDA #$00
	STA WSYNC
	STA VBLANK
	LDA #$FF
	STA GRP0
	LDX #$00
drawscr	LDY #$0C
doline	LDA color,X
	STA COLUP0
	STA WSYNC
	DEY
	BNE doline
	INX
	CPX #$10
	BNE drawscr
done	LDA #$00
	STA GRP0
	STA WSYNC
	STA VBLANK

oscan   LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

color	.byte $00,$10,$20,$30,$40,$50,$60,$70
	.byte $80,$90,$A0,$B0,$C0,$D0,$E0,$F0

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
	.word Start
