; Dodge Ball without players, missiles, or ball
; Charles Wieland, 3/16/1998
; junkosoft.org

	processor 6502
	include vcs.h

	org $F000

CURCOLOR = $80

; Main Program and Initialization

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00

clrstk  STA $00,X
	DEX
	BNE clrstk
	LDA #$01
	STA CTRLPF
	LDA #$FF
	STA PF0
	STA PF1
	STA PF2
	
; Vertical Blank Handler

vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	STA HMOVE
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC
	; Check Collisions
	LDA #$00
	STA CXCLR

; Color Setup Routine
 
vars	LDA SWCHB
	AND #$08
	BEQ bw

color	LDA #$40
	STA CURCOLOR
	JMP draw

bw	LDA #$00
	STA CURCOLOR
	
; Screen Draw routine

draw    LDA INTIM
	BNE draw
	STA WSYNC
	STA VBLANK
	STA COLUPF
	LDX #$1C
drawtop STA WSYNC
	DEX
	BNE drawtop
	LDX #$10
	LDY CURCOLOR
topcol  STY COLUPF
	STA WSYNC
	INY
	DEX
	BNE topcol
	STX COLUPF
	LDX #$68	
sprdraw ; Sprite logic here
	STA WSYNC
	DEX
	BNE sprdraw	
	LDX #$10
botcol  DEY
	STY COLUPF
	STA WSYNC
	DEX
	BNE botcol
	LDY #$00
	STY COLUPF
	LDX #$1C
drawbot STA WSYNC
	DEX
	BNE drawbot
clear   LDA #$02
	STA WSYNC
	STA VBLANK

; Overscan and Joystick routine

oscan   LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

	org $FFFC
	.word Start
	.word Start     
