; Junkosoft 1 Year Party Demo
; Charles Wieland, 1/10/1999
; junkosoft.org

	processor 6502
	include vcs.h

	ORG $F000

COLOR = $80

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00
	
clrstk  STA $00,X
	DEX
	BNE clrstk
	
vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC

doscrn  LDA INTIM
	BNE doscrn

	INC COLOR
	LDA COLOR
	STA COLUPF

dodraw  LDA #$00
	STA WSYNC
	STA VBLANK
	LDX #$20
drawscr LDY #$06
	DEX
drawblk	LDA lpf0,X
	STA PF0
	LDA lpf1,X
	STA PF1
	LDA lpf2,X
	STA PF2	
	NOP	
	LDA rpf0,X
	STA PF0
	LDA rpf1,X
	STA PF1
	LDA rpf2,X
	STA PF2
	STA WSYNC
	DEY
	BNE drawblk
	
	CPX #$00
	BNE drawscr
	
	LDA #$00
	STA COLUPF
	STA WSYNC
	STA VBLANK
	
oscan   LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

lpf0	.byte $00,$00,$00,$70,$20,$20,$30,$20
	.byte $00,$FF,$00,$70,$10,$10,$10,$70
	.byte $00,$00,$00,$00,$00,$00,$00,$FF
	.byte $00,$E0,$80,$80,$80,$E0,$00,$00
lpf1	.byte $00,$00,$00,$83,$41,$21,$13,$09
	.byte $00,$FF,$00,$AE,$A8,$EE,$A8,$AE
	.byte $00,$E0,$40,$41,$C1,$41,$00,$FF
	.byte $00,$3D,$25,$25,$25,$A5,$00,$00
lpf2	.byte $00,$00,$00,$5D,$90,$1C,$04,$1C
	.byte $00,$FF,$00,$77,$41,$77,$11,$77
	.byte $00,$B9,$89,$BB,$8A,$BA,$00,$FF
	.byte $00,$54,$54,$36,$55,$54,$00,$00

rpf0	.byte $00,$00,$00,$00,$00,$10,$20,$40
	.byte $00,$FF,$00,$20,$20,$70,$50,$50
	.byte $00,$A0,$A0,$B0,$A0,$B0,$00,$FF
	.byte $00,$70,$50,$50,$50,$70,$00,$00
rpf1	.byte $00,$00,$00,$E2,$42,$4E,$CA,$4E
	.byte $00,$FF,$00,$75,$45,$46,$45,$77
	.byte $00,$43,$42,$82,$42,$C3,$00,$FF
	.byte $00,$EE,$2A,$EA,$8A,$EE,$00,$00
rpf2	.byte $00,$00,$00,$44,$44,$77,$55,$77
	.byte $00,$FF,$00,$2A,$2A,$EE,$AA,$EE
	.byte $00,$05,$05,$1D,$05,$1D,$00,$FF
	.byte $00,$21,$21,$27,$21,$77,$00,$00

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
	.word Start
