; Nonreflected Color Scrolling Demo
; Charles Wieland, 6/13/1998
; junkosoft.org

	processor 6502
	include vcs.h

CURCOLOR = $80
TMPCOL   = $81
	
	org $F000

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00

clrstk  STA $00,X
	DEX
	BNE clrstk
	STX CURCOLOR
	STX CTRLPF
	
vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC

doscrn  LDA INTIM
	BNE doscrn
	LDA #$00
	STA WSYNC
	STA VBLANK
	STA PF0
	STA PF1
	STA PF2
	LDX #$12
	LDY CURCOLOR
toploop STY COLUBK
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	INY
	DEX
	BNE toploop

	DEY
	STY TMPCOL
	LDX #$06
	STA WSYNC
midloop LDY #$08
	DEX
line	LDA left0,X
	STA PF0
	LDA left1,X
	STA PF1
	LDA left2,X
	STA PF2
	LDA right0,X
	STA PF0
	LDA right1,X
	STA PF1
	LDA right2,X
	STA PF2
	STA WSYNC
	DEY
	BNE line
	CPX #$00
	BNE midloop

	LDA #$00
	STA PF0
	STA PF1
	STA PF2
	LDY TMPCOL
	LDX #$12
drawbot	STY COLUBK
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	DEY
	DEX
	BNE drawbot
	LDA #$00
	STA COLUBK
	INC CURCOLOR
	STA WSYNC
	STA VBLANK

	LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

left0	.byte $E0,$80,$80,$80,$80,$E0
left1	.byte $3D,$25,$25,$25,$25,$A5
left2	.byte $54,$54,$36,$35,$54,$54
right0	.byte $70,$50,$50,$50,$50,$70
right1	.byte $EE,$2A,$2A,$EA,$8A,$EE
right2	.byte $21,$21,$21,$27,$21,$77

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
	.word Start
 
