; Moveable Color Spectum Demo
; Charles Wieland, 6/13/1998
; junkosoft.org

	processor 6502
	include vcs.h

CURCOLOR = $80

	ORG $F000

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00

clrstk  STA $00,X
	DEX
	BNE clrstk
	STX CURCOLOR
	
vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC

doscrn  LDA INTIM
	BNE doscrn
	LDA #$00
	STA WSYNC
	STA VBLANK
	LDX #$C0
	LDY CURCOLOR
drawscr	STA WSYNC
	STY COLUBK
	INY
	INY
	DEX
	BNE drawscr
	LDA #$00
	STA COLUBK

	LDA SWCHA
	AND #$F0
	CMP #$E0
	BEQ up
	CMP #$D0
	BEQ down
	JMP oscan

up	INC CURCOLOR
	JMP oscan

down	DEC CURCOLOR

oscan	LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
	.word Start