; Vertical Color Scrolling Demo
; Charles Wieland, 3/9/1998
; Junkosoft.org

	PROCESSOR 6502

CURCOLOR = $80
TEMP	 = $81

	INCLUDE VCS.H
	ORG $F000

start   SEI
	CLD
	LDX #$FF
	TXS
        LDA #$00
clrstk  STA $00,X
	DEX
	BNE clrstk
        LDA #$44
        STA CURCOLOR
	STA COLUBK
	LDA #$01
	STA CTRLPF

vertb   LDX #$00
	LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA CXCLR
	STA WSYNC
	STA VSYNC

draw	LDA INTIM
	BNE draw
	STA WSYNC
	STA VBLANK
	LDA #$FF
	STA PF0
	STA PF1
	STA PF2
	LDX #$C0
	LDY CURCOLOR
drawscr	STY COLUPF
	STA WSYNC
	INY
	DEX
	BNE drawscr
done	INC CURCOLOR
	LDA #$02
	STA WSYNC
	STA VBLANK
		
oscan   LDX #$1E
doscan  STA WSYNC
	DEX
        BNE doscan
        JMP vertb

	ORG $FF00
pfdata0 .byte $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	.byte $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
	.byte $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
pfdata1 .byte $00,$00,$00,$06,$03,$01,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00
pfdata2 .byte $00,$00,$00,$C0,$C0,$C1,$C3,$C6
	.byte $C6,$CC,$CC,$D8,$D8,$D8,$D8,$D8
	.byte $D8,$D8,$D8,$D8,$00,$00,$00,$00

	ORG $FFFC
	.word start
	.word start
