; Vertical Scrolling Shoot-em up
; Charles Wieland, 4/13/1998
; junkosoft.org

	processor 6502
	include vcs.h

	org $F000

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00

clrstk  STA $00,X
	DEX
	BNE clrstk
	STX PF1
	STX PF2

	LDX #$5C
topfrm  STA WSYNC
	DEX
	BNE topfrm
	LDX #$90
delay   DEX
	BNE delay
	STA RESP0
	NOP
	STA RESP1
	STA WSYNC
	LDX #$63
btmfrm  STA WSYNC
	DEX
	BNE btmfrm

vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC
	STA HMOVE
	LDA #$00
	STA CXCLR

	LDA SWCHB
	AND #$08
	BEQ bw

color   LDA #$34
	STA COLUPF
	JMP vars

bw      LDA #$08
	STA COLUPF

vars	LDA SWCHB
	AND #$08
	BEQ down

up	LDA #$34
	STA COLUP0
	JMP draw

down	LDA #$08
	STA COLUP0

draw    LDA INTIM
	BNE draw
	STA WSYNC
	STA VBLANK
	LDX #$B0
drawtop STA WSYNC
	DEX
	BNE drawtop
loadspr	LDA sprdata,X
	STA GRP0
	STA WSYNC
	INX
	CPX #$08
	BNE loadspr
bottom	LDA #$00
	STA GRP0
drawbot	STA WSYNC
	DEX
	BNE drawbot
clear	STA WSYNC
	STA VBLANK

oscan   LDA SWCHA
	AND #$F0
	CMP #$B0
	BEQ left0
	CMP #$70
	BEQ right0
	LDX #$00
	STX HMP0
	JMP done

left0   LDA #$10
	STA HMP0
	JMP done

right0  LDA #$F0
	STA HMP0

done	LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

sprdata	.byte $18,$18,$3C,$3C,$7E,$7E,$FF,$FF

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
	.word Start
