; Multi Sprite Demo
; Charles Wieland, 12/20/1998
; junkosoft.org

	processor 6502
	include vcs.h

	ORG $F000

DELAY = $80

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00
	
clear	STA $00,X
	DEX
	BNE clear
		
vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC

doscrn  LDA INTIM
	BNE doscrn

dodraw  LDA #$00
	STA WSYNC
	STA VBLANK
	STA RESP0

	LDX #$08
	LDY #$0E
drawtop	STY COLUBK
	STA WSYNC
	STA WSYNC
	STA WSYNC
	DEY
	DEY
	DEX
	BNE drawtop

	LDA #$01
	STA DELAY
	LDX #$10 ; Sixteen Sprites	
drawscr LDY #$00

drawspr	LDA cart,Y
	STA GRP0
	LDA cartcol,Y
	STA COLUP0
	STA WSYNC
	INY
	CPY #$08
	BNE drawspr

	LDA #$00
	STA GRP0
	LDY DELAY
delay	DEY
	BPL delay
	STA RESP0
	STA WSYNC
	INC DELAY
	DEX
	BNE drawscr

	LDX #$08
	LDY #$0E
drawbot	STY COLUBK
	STA WSYNC
	STA WSYNC
	STA WSYNC
	DEY
	DEY
	DEX
	BNE drawbot

	STA WSYNC
	STA VBLANK
	
oscan   LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

cart	.byte $E0,$2A,$15,$2A,$15,$2A,$00,$22
cartcol	.byte $04,$0F,$0F,$0F,$0F,$0F,$0F,$02

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
	.word Start
