; Nonreflected Color Scrolling Demo
; Charles Wieland, 6/11/1998
; junkosoft.org

	processor 6502
	include vcs.h

CURCOLOR = $80
	
	org $F000

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00

clrstk  STA $00,X
	DEX
	BNE clrstk
	STX CURCOLOR
	
vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC

doscrn  LDA INTIM
	BNE doscrn
	LDA #$00
	STA WSYNC
	STA VBLANK
	STA PF0
	STA PF1
	STA PF2
	LDX #$12
	LDY CURCOLOR
toploop STY COLUBK
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	INY
	DEX
	BNE toploop

	LDX #$30
midloop STA WSYNC
	DEX
	BNE midloop

	DEY
	LDX #$12
drawbot	STY COLUBK
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	DEY
	DEX
	BNE drawbot
	LDA #$00
	STA COLUBK
	INC CURCOLOR
	STA WSYNC
	STA VBLANK

	LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

left0	.byte $F0,$40,$40,$40,$40,$70
left1	.byte $A3,$25,$25,$25,$25,$3D
left2	.byte $54,$54,$35,$36,$54,$54
right0	.byte $70,$50,$50,$50,$50,$70
right1	.byte $EE,$8A,$EA,$2A,$2A,$EE
right2	.byte $77,$21,$27,$21,$21,$21

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
	.word Start
 
