; Sky Demo
; Charles Wieland, 11/28/1998
; junkosoft.org

	processor 6502
	include vcs.h

	ORG $F000

FRAME = $80
TEMP  = $81

Start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00
	
clrstk  STA $00,X
	DEX
	BNE clrstk
	LDA #$01
	STA CTRLPF

vblank  LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA WSYNC
	STA VSYNC

doscrn  LDA INTIM
	BNE doscrn

dodraw  LDA #$00
	STA WSYNC
	STA VBLANK
	LDA #$00
	STA COLUBK
	LDX #$0F
drawsky STA WSYNC
	DEX
	BNE drawsky

	LDA #$04
	STA COLUPF
	LDX #$0F
horizon	DEX
	LDA hc,X
	STA COLUBK
	LDY #$04
	LDA lh0,X
	STA PF0
	LDA lh1,X
	STA PF1
	LDA lh2,X
	STA PF2
	STA WSYNC
	TXA
	BNE horizon

	LDA #$00
	STA PF0
	STA PF1
	STA PF2	

	LDY #$96
	STY COLUBK
	LDX #$93
water	STA WSYNC
	DEX
	BNE water

	LDA #$00
	STA COLUBK
	LDX #$0A
bottom	STA WSYNC
	DEX
	BNE bottom
	STA WSYNC
	STA VBLANK
	
oscan   LDX #$1E
doscan  STA WSYNC
	DEX
	BNE doscan
	JMP vblank

hc	.byte $00,$00,$00,$1E,$1C,$1A,$18,$16,$14,$12
	.byte $12,$10,$10,$00,$00,$00,$00,$00,$00,$00
lh0	.byte $F0,$F0,$F0,$F0,$F0,$E0,$40,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
lh1	.byte $FF,$FF,$FF,$CF,$87,$02,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
lh2	.byte $FF,$FF,$FF,$F9,$F8,$F0,$E0,$E0,$E0,$C0
	.byte $C0,$80,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00

	org $F7FC
	.word Start
	.word Start

	org $FFEB
	dc.b "(c)1998 JunkoSoft"
	.word Start
	.word Start
