; Playfield Demo        
; James Blair 
; Junkosoft
; Jan 19, 1998


	PROCESSOR 6502
	
	INCLUDE vcs.h
	ORG $F000
 
start   SEI
	CLD
	LDX #$FF
	TXS
	LDA #$00

clear   STA $00,X
	DEX
	BNE clear

main    JSR vblank
	JSR init
	JSR drawscr
	JSR oscan
	JMP main

init    LDA #$00
	STA COLUBK
	LDA #$32
	STA COLUPF
	LDA #$01
	STA CTRLPF
	RTS

vblank  LDX #$00
	LDA #$02
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	LDA #$2C
	STA TIM64T
	LDA #$00
	STA CXCLR
	STA WSYNC
	STA VSYNC
	RTS

drawscr LDA INTIM
	BNE drawscr
	STA WSYNC
	STA VBLANK
	LDY #$06
	LDX #$1F

ldpf    LDA pfdata0,X
	STA PF0
	LDA pfdata1,X
	STA PF1
	LDA pfdata2,X
	STA PF2

dl      STA WSYNC
	DEY
	BNE dl
	TXA
	BEQ clr
	DEX
	LDY #$06
	JMP ldpf

clr     LDA #$02
	STA WSYNC
	STA VBLANK
        LDX PF0
	LDX PF1
	LDX PF2
	RTS

oscan   LDX #$1E

dieln   STA WSYNC
	DEX 
	BNE dieln
	RTS
	ORG $FF00

pfdata0 .byte $00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$80,$80,$00,$00,$00,$00,$00,$40
	.byte $C0,$C0,$C0,$C0,$80,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00

pfdata1 .byte $00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$CE,$CE,$CC,$CC,$CC,$CC,$78,$79
	.byte $7B,$7B,$7B,$7B,$FE,$78,$CC,$84,$84
	.byte $CC,$78,$30,$00,$00

pfdata2 .byte $00,$00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$70,$70,$60,$60,$60,$60,$C0,$C8
	.byte $D8,$D8,$D8,$D8,$F0,$C0,$60,$20,$20
	.byte $60,$C0,$80,$00,$00

	ORG $FFFC
	.word start
	.word start
